<%@page import="org.apache.catalina.connector.Request"%>
<%@ page contentType="text/html;charset=UTF-8" language="java"%>

<%@ page
	import="java.util.List,
                 java.util.ArrayList,
                 java.util.Collections,
                 java.util.Iterator,
                 java.util.Enumeration,
                 java.security.MessageDigest,
                 java.util.Map,
                 java.net.URLEncoder,
                 java.util.HashMap"%>

<%!// Define Constants
	// ****************
	/* Note:
	   ----
	   In a proper production environment, only the retrieving of all the input 
	   parameters and the HTML output would be in this file. The following 
	   constants and all other methods would be contained in a separate helper
	   class so that users could not gain access to these values. */

	// This is secret for encoding the SHA256 hash
	// This secret will vary from merchant to merchant
	// static final String SECURE_SECRET = "your-secure-hash-secret";
	//SMLTEST
	static final String SECURE_SECRET = "ABCD";

	String getValue(String in) {
		if (in == null || in.length() == 0) {
			return "Không có giá trị trả về";
		} else {
			return in;
		}
	}
	//--------------------------------------------------------------------------
		String hash(String message, String algorithm ) {
			MessageDigest md;
			byte byteData[];
			try {
				md = MessageDigest.getInstance(algorithm);
				md.update(message.getBytes("UTF-8"));
				byteData = md.digest();
			} catch (Exception e) {
				e.printStackTrace();
				return null;
			}

			StringBuffer sb = new StringBuffer();
			for (int i = 0; i < byteData.length; i++) {
				sb.append(Integer.toString((byteData[i] & 0xff) + 0x100, 16)
						.substring(1));
			}

			return sb.toString();
		}
		//--------------------------------------------------------------------------
		/**
		*This method is for sorting the fields and creating an SHA256 secure hash
		*@param parameters
		**/
		//--------------------------------------------------------------------------
		String getSecureHash(Map<String, String> parameters) {
			List<String> keyList = new ArrayList<String>(parameters.keySet());
			// Sắp xếp thự tự tham số
			Collections.sort(keyList);
			StringBuilder valueFormated = new StringBuilder();
			for (String key : keyList) {
				valueFormated.append(parameters.get(key));
				valueFormated.append("|");
			}
			String secureHash = hash(SECURE_SECRET
					+ "|"
					+ valueFormated.toString().substring(0,
							valueFormated.length() - 1), "SHA-256");
			return secureHash;
		}
		//--------------------------------------------------------------------------
	%>
<%
	String version = request.getParameter("version");
	String locale = request.getParameter("locale");
	String merchant_site = request.getParameter("merchant_site");
	String order_no = request.getParameter("order_no");
	String request_time = request.getParameter("request_time");
	String total_amount = request.getParameter("total_amount");
	String currency = request.getParameter("currency");
	String transaction_no = request.getParameter("transaction_no");
	String response_code = request.getParameter("response_code");
	String message = request.getParameter("message");
	String response_time = request.getParameter("response_time");
	String security_hash = request.getParameter("secure_hash");
	//-----------------------------------------------------------------
	// Check hash
	Map<String, String> fields = new HashMap<String, String>();
	for (Enumeration<String> enumeration = request.getParameterNames(); enumeration
			.hasMoreElements();) {
		String fieldName = (String) enumeration.nextElement();
		String fieldValue = request.getParameter(fieldName);
		if ((fieldValue != null) && (fieldValue.length() > 0)) {
			fields.put(fieldName, fieldValue);
		}
	}
	fields.remove("secure_hash");
	
	String client_hash = getSecureHash(fields);
	String checkHashStr = client_hash.equals(security_hash) ? "Hợp lệ" : "Không hợp lệ";
	//--------------------------------------------------------------------------
%>
<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN'>
<html>
<head>
<title>VIVIET PAYMENT GATEWAY</title>
<meta http-equiv='Content-Type' content='text/html, charset=utf-8'>
<style type='text/css'>
<!--
h1 {
	font-family: Arial, sans-serif;
	font-size: 20pt;
	font-weight: 600;
	margin-bottom: 0.1em;
	color: #08185A;
}

h2 {
	font-family: Arial, sans-serif;
	font-size: 14pt;
	font-weight: 100;
	margin-top: 0.1em;
	color: #08185A;
}

h2.co {
	font-family: Arial, sans-serif;
	font-size: 24pt;
	font-weight: 100;
	margin-top: 0.1em;
	margin-bottom: 0.1em;
	color: #08185A
}

h3 {
	font-family: Arial, sans-serif;
	font-size: 16pt;
	font-weight: 100;
	margin-top: 0.1em;
	margin-bottom: 0.1em;
	color: #08185A
}

h3.co {
	font-family: Arial, sans-serif;
	font-size: 16pt;
	font-weight: 100;
	margin-top: 0.1em;
	margin-bottom: 0.1em;
	color: #FFFFFF
}

body {
	font-family: Verdana, Arial, sans-serif;
	font-size: 10pt;
	background-color: #FFFFFF;
	color: #08185A
}

th {
	font-family: Verdana, Arial, sans-serif;
	font-size: 8pt;
	font-weight: bold;
	background-color: #E1E1E1;
	padding-top: 0.5em;
	padding-bottom: 0.5em;
	color: #08185A
}

tr {
	height: 25px;
}

.shade {
	height: 25px;
	background-color: #E1E1E1
}

.title {
	height: 25px;
	background-color: #C1C1C1
}

td {
	font-family: Verdana, Arial, sans-serif;
	font-size: 8pt;
	color: #08185A
}

td.red {
	font-family: Verdana, Arial, sans-serif;
	font-size: 8pt;
	color: #FF0066
}

td.green {
	font-family: Verdana, Arial, sans-serif;
	font-size: 8pt;
	color: #008800
}

p {
	font-family: Verdana, Arial, sans-serif;
	font-size: 10pt;
	color: #FFFFFF
}

p.blue {
	font-family: Verdana, Arial, sans-serif;
	font-size: 7pt;
	color: #08185A
}

p.red {
	font-family: Verdana, Arial, sans-serif;
	font-size: 7pt;
	color: #FF0066
}

p.green {
	font-family: Verdana, Arial, sans-serif;
	font-size: 7pt;
	color: #008800
}

div.bl {
	font-family: Verdana, Arial, sans-serif;
	font-size: 7pt;
	color: #C1C1C1
}

div.red {
	font-family: Verdana, Arial, sans-serif;
	font-size: 7pt;
	color: #FF0066
}

li {
	font-family: Verdana, Arial, sans-serif;
	font-size: 8pt;
	color: #FF0066
}

input {
	font-family: Verdana, Arial, sans-serif;
	font-size: 8pt;
	color: #08185A;
	background-color: #E1E1E1;
	font-weight: bold
}

select {
	font-family: Verdana, Arial, sans-serif;
	font-size: 8pt;
	color: #08185A;
	background-color: #E1E1E1;
	font-weight: bold;
}

textarea {
	font-family: Verdana, Arial, sans-serif;
	font-size: 8pt;
	color: #08185A;
	background-color: #E1E1E1;
	font-weight: normal;
	scrollbar-arrow-color: #08185A;
	scrollbar-base-color: #E1E1E1
}
-->
</style>
</head>
<body>
	<table width="90%" align="center" border="0" cellpadding='0'
		cellspacing='0'>
		<tr>
			<td height="70" colspan="2"><h1>WEBSITE THƯƠNG MẠI ĐIỆN TỬ</h1></td>
		</tr>
		<tr>
			<td background="images/header_bg.gif"></td>
			<td height="60" background="images/header_bg.gif">
				<h1>Thông tin kết quả thanh toán</h1>
			</td>
		</tr>
		<tr>
			<td><img src="images/shoppingcart.jpg" border="0"></td>
			<td width="80%" valign="top">

				<center>

					<center>
						<h2></h2>
					</center>

					<table width="100%" align='center' cellpadding='5' border='0'>

						<tr class='title'>
							<td colspan="2" height="25"><p>
									<strong>Thông tin giao dịch</strong>
								</p></td>
						</tr>
						<tr>
							<td align='right' width='50%'><strong><i>
										Version: </i></strong></td>
							<td width='50%'><%=version%></td>
						</tr>
						<tr class='shade'>
							<td align='right'><strong><i>Locale: </i></strong></td>
							<td><%=locale%></td>
						</tr>
						<tr>
							<td align='right'><strong><i>Merchant Site ID:
								</i></strong></td>
							<td><%=merchant_site%></td>
						</tr>
						<tr class='shade'>
							<td align='right'><strong><i>Order_no : </i></strong></td>
							<td><%=order_no%></td>
						</tr>
						<tr>
							<td align='right'><strong><i>Total_amount: </i></strong></td>
							<td><%=total_amount%></td>
						</tr>
						<tr class='shade'>
							<td align='right'><strong><i>Currency: </i></strong></td>
							<td><%=currency%></td>
						</tr>

						<tr class='title'>
							<td colspan="2" height="25"><p>
									<strong>Thông tin về kết quả giao dịch</strong>
								</p></td>
						</tr>
						<tr>
							<td align='right'><strong><i>Request_time: </i></strong></td>
							<td><%=request_time%></td>
						</tr>
						<tr class='shade'>
							<td align='right'><strong><i>Transaction_no: </i></strong></td>
							<td><%=transaction_no%></td>
						</tr>
						<tr>
							<td align='right'><strong><i>Response_code: </i></strong></td>
							<td><%=response_code%></td>
						</tr>

						<tr class='shade'>
							<td align='right'><strong><i>Message: </i></strong></td>
							<td><%=message%></td>
						</tr>
						<tr>
							<td align='right'><strong><i>Response_time: </i></strong></td>
							<td><%=response_time%></td>
						</tr>

						<tr class='title'>
							<td colspan="2" height="25"><p>
									<strong>Kiểm tra Hash</strong>
								</p></td>
						</tr>
						<tr>
							<td align="right"><strong><i>Kiểm tra giá trị
										Hash: </i></strong></td>
							<td><%=checkHashStr%></td>
						</tr>

					</table>
					<br />

				</center>
			</td>
		</tr>
	</table>
</body>
</html>
